diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 2a8647a40..1c85d76a4 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -292,34 +292,34 @@ fun generateMcPatchesFile(inputDir: File, outputDir: File, sbom: File) {
     patchMC.writeText(gson.toJson(json))
 }
 
-val testShaders by tasks.registering {
-    outputs.upToDateWhen { false }
-
-    val shaderDir = project.layout.projectDirectory.dir("/src/main/resources/shaders/").asFile
-
-    shaderDir.walkTopDown().forEach { file ->
-        run {
-            if (file.isFile) {
-                val type = when(file.extension) {
-                    "fsh" -> "frag"
-                    "gsh" -> "geom"
-                    "vsh" -> "vert"
-                    else -> throw RuntimeException("Unknown shader type '${file.extension}' in shader '${file.canonicalPath}'!")
-                }
-                val command = "glslangValidator ${file.canonicalPath} -S $type"
-                val process = command.runCommand(shaderDir)
-                process.waitFor(60, TimeUnit.MINUTES)
-                if (process.exitValue() != 0) {
-                    System.err.println("Failed to compile shader file:///${file.canonicalPath.replace("\\", "/")}")
-                    System.out.print(process.inputStream.bufferedReader().readText())
-                    throw RuntimeException(process.errorStream.bufferedReader().readText())
-                } else{
-                    print(process.inputStream.bufferedReader().readText())
-                }
-            }
-        }
-    }
-}
+//val testShaders by tasks.registering {
+//    outputs.upToDateWhen { false }
+//
+//    val shaderDir = project.layout.projectDirectory.dir("/src/main/resources/shaders/").asFile
+//
+//    shaderDir.walkTopDown().forEach { file ->
+//        run {
+//            if (file.isFile) {
+//                val type = when(file.extension) {
+//                    "fsh" -> "frag"
+//                    "gsh" -> "geom"
+//                    "vsh" -> "vert"
+//                    else -> throw RuntimeException("Unknown shader type '${file.extension}' in shader '${file.canonicalPath}'!")
+//                }
+//                val command = "glslangValidator ${file.canonicalPath} -S $type"
+//                val process = command.runCommand(shaderDir)
+//                process.waitFor(60, TimeUnit.MINUTES)
+//                if (process.exitValue() != 0) {
+//                    System.err.println("Failed to compile shader file:///${file.canonicalPath.replace("\\", "/")}")
+//                    System.out.print(process.inputStream.bufferedReader().readText())
+//                    throw RuntimeException(process.errorStream.bufferedReader().readText())
+//                } else{
+//                    print(process.inputStream.bufferedReader().readText())
+//                }
+//            }
+//        }
+//    }
+//}
 
 tasks.cyclonedxBom {
     setIncludeConfigs(listOf("runtimeClasspath"))
diff --git a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 03eff517c..744f0ece3 100644
--- a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -54,7 +54,13 @@ public class RichPresenceHandlerThread extends Thread {
         biomeNamesMap.put(Biomes.OVERWORLD_GLACIER, "a glacier");
         biomeNamesMap.put(Biomes.OVERWORLD_TUNDRA, "a tundra");
         biomeNamesMap.put(Biomes.OVERWORLD_MEADOW, "a meadow");
-        biomeNamesMap.put(Biomes.NETHER_NETHER, "Hell itself");
+        biomeNamesMap.put(Biomes.NETHER_CRAG, "the crag");
+        biomeNamesMap.put(Biomes.NETHER_CRYSTAL_FOREST, "a crystal forest");
+        biomeNamesMap.put(Biomes.NETHER_CRYSTAL_FIELD, "a crystal field");
+        biomeNamesMap.put(Biomes.NETHER_SULFUR_POOLS, "the sulfur pools");
+        biomeNamesMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, "a volcanic island");
+        biomeNamesMap.put(Biomes.NETHER_OLD_WORLD, "the crag (cold)");
+        biomeNamesMap.put(Biomes.NETHER_SHELF, "the shelf");
         biomeNamesMap.put(Biomes.DRIFT_DRIFT, "the skies");
         biomeNamesMap.put(Biomes.OVERWORLD_BIRCH_FOREST, "a birch forest");
         biomeNamesMap.put(Biomes.OVERWORLD_RETRO, "a world long forgotten");
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 0caf8c889..8940c6dfa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -134,9 +134,16 @@ public class FogManager {
             this.fogBlue = out[2];
         }
         if (CameraUtil.isUnderLiquid(this.mc.activeCamera, world, Materials.WATER, partialTick)) {
-            this.fogRed = 0.02F;
-            this.fogGreen = 0.02F;
-            this.fogBlue = 0.2F;
+            if(this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
+                this.fogRed = 0.2F;
+                this.fogGreen = 0.02F;
+                this.fogBlue = 0.02F;
+            } else {
+                this.fogRed = 0.02F;
+                this.fogGreen = 0.02F;
+                this.fogBlue = 0.2F;
+            }
+
             if (GameSettings.BIOME_WATER.value) {
                 TilePos cameraTile = this.mc.activeCamera.getTilePos();
                 double temp = world.getBlockTemperature(cameraTile);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index bf48ba4b2..70dab5980 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.block.color;
 
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
@@ -49,9 +48,9 @@ public final class BlockColorDispatcher
         addDispatch(Blocks.WIRE_REDSTONE, new BlockColorWireRedstone());
         addDispatch(Blocks.TALLGRASS, new BlockColorCustom(Colorizers.grass));
         addDispatch(Blocks.TALLGRASS_FERN, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Blocks.CRYSTAL, new BlockColorCrystal(Colorizers.crystal));
-        addDispatch(Blocks.CRYSTAL_STALK, new BlockColorCrystal(Colorizers.crystal));
-        addDispatch(Blocks.NETHERRACK_CRYSTALLINE, new BlockColorCrystal(Colorizers.crystal));
+        addDispatch(Blocks.RUBYGLASS, new BlockColorRubyglass(Colorizers.crystal));
+        addDispatch(Blocks.RUBYGLASS_PURE, new BlockColorRubyglass(Colorizers.crystal));
+        addDispatch(Blocks.RUBYGLASS_SPROUT, new BlockColorRubyglass(Colorizers.crystal));
     }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglass.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglass.java
new file mode 100644
index 000000000..0d4b712e7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorRubyglass.java
@@ -0,0 +1,28 @@
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class BlockColorRubyglass extends BlockColorCustom{
+
+    public BlockColorRubyglass(Colorizer colorizer) {
+        super(colorizer);
+    }
+
+    @Override
+    public int getFallbackColor(int meta, int tintIndex) {
+        return 0xFFC40E26;
+    }
+
+    @Override
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+
+        int color = 0xFFC40E26;
+        return color;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquaresRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquaresRotatable.java
new file mode 100644
index 000000000..67b58fea4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquaresRotatable.java
@@ -0,0 +1,133 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.*;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+public class BlockModelCrossedSquaresRotatable<T extends BlockLogic> extends BlockModelCrossedSquares<T> {
+    public BlockModelCrossedSquaresRotatable(Block<T> block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        float brightness = 1.0f;
+        tessellator.setLightmapCoord1i(block.getLightIndex(worldSource, tilePos));
+
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, tilePos, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
+        tessellator.setColorOpaque3f(brightness * r, brightness * g, brightness * b);
+
+        int metadata = worldSource.getBlockData(tilePos);
+        Direction dir = BlockLogicRotatable.getDirectionFromMeta(metadata);
+
+        IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
+        if (renderBlocks.overrideBlockTexture != null) {
+            texIndex = renderBlocks.overrideBlockTexture;
+        }
+
+        final double minX = -0.45D;
+        final double maxX =  0.45D;
+        final double minY = -0.5D;
+        final double maxY =  0.5D;
+        final double minZ = -0.45D;
+        final double maxZ =  0.45D;
+
+        final double minU = texIndex.getIconUMin();
+        final double maxU = texIndex.getIconUMax();
+        final double minV = texIndex.getIconVMin();
+        final double maxV = texIndex.getIconVMax();
+
+        final boolean flipUVs = dir == Direction.WEST || dir == Direction.SOUTH || dir == Direction.DOWN;
+
+        Vec3[] vertices = new Vec3[8];
+
+        vertices[0] = Vec3.getTempVec3(minX, maxY, minZ);
+        vertices[1] = Vec3.getTempVec3(minX, minY, minZ);
+        vertices[2] = Vec3.getTempVec3(maxX, minY, maxZ);
+        vertices[3] = Vec3.getTempVec3(maxX, maxY, maxZ);
+        vertices[4] = Vec3.getTempVec3(minX, maxY, maxZ);
+        vertices[5] = Vec3.getTempVec3(minX, minY, maxZ);
+        vertices[6] = Vec3.getTempVec3(maxX, minY, minZ);
+        vertices[7] = Vec3.getTempVec3(maxX, maxY, minZ);
+
+
+        for (int vi = 0; vi < 8; vi++) {
+            switch (dir){
+                case NORTH:
+                    vertices[vi].rotateAroundX(-MathHelper.PI / 2f);
+                    break;
+                case SOUTH:
+                    vertices[vi].rotateAroundX(MathHelper.PI / 2f);
+                    break;
+                case EAST:
+                    vertices[vi].rotateAroundZ(-MathHelper.PI / 2f);
+                    break;
+                case WEST:
+                    vertices[vi].rotateAroundZ(MathHelper.PI / 2f);
+                    break;
+                case DOWN:
+                    vertices[vi].rotateAroundX(MathHelper.PI);
+                    break;
+            }
+
+            vertices[vi].rotateAroundY(MathHelper.PI);
+            vertices[vi].x += (float) tilePos.x() + 0.5D;
+            vertices[vi].y += (float) tilePos.y() + 0.5D;
+            vertices[vi].z += (float) tilePos.z() + 0.5D;
+        }
+
+        for (int side = 0; side < 4; side++) {
+
+            Vec3 v1;
+            Vec3 v2;
+            Vec3 v3;
+            Vec3 v4;
+            if (side == 0) {
+                v1 = vertices[0]; // minX, maxY, minZ
+                v2 = vertices[1]; // minX, minY, minZ
+                v3 = vertices[2]; // maxX, minY, maxZ
+                v4 = vertices[3]; // maxX, maxY, maxZ
+            } else if (side == 1) {
+                v1 = vertices[3]; // maxX, maxY, maxZ
+                v2 = vertices[2]; // maxX, minY, maxZ
+                v3 = vertices[1]; // minX, minY, minZ
+                v4 = vertices[0]; // minX, maxY, minZ
+            } else if (side == 2) {
+                v1 = vertices[4]; // minX, maxY, maxZ
+                v2 = vertices[5]; // minX, minY, maxZ
+                v3 = vertices[6]; // maxX, minY, minZ
+                v4 = vertices[7]; // maxX, maxY, minZ
+            } else {
+                v1 = vertices[7]; // maxX, maxY, minZ
+                v2 = vertices[6]; // maxX, minY, minZ
+                v3 = vertices[5]; // minX, minY, maxZ
+                v4 = vertices[4]; // minX, maxY, maxZ
+            }
+            tessellator.addVertexWithUV(v1.x, v1.y, v1.z, minU, minV);
+            tessellator.addVertexWithUV(v2.x, v2.y, v2.z, minU, maxV);
+            tessellator.addVertexWithUV(v3.x, v3.y, v3.z, maxU, maxV);
+            tessellator.addVertexWithUV(v4.x, v4.y, v4.z, maxU, minV);
+        }
+
+        return true;
+    }
+
+    @Override
+    public boolean shouldItemRender3d() {
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 07f27b380..9b15b77c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -2,62 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericActivator;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericAxis;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericBasket;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericBed;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericBrazier;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericButton;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericButtonPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericCake;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericChest;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericChestPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericCropsPumpkin;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericDoor;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericDoorPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFarmland;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFence;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceGate;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceGatePainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFencePainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceThin;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFlowerStackable;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFullyRotatable;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericFurnace;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericGrass;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLayer;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLever;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericMatcher;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPebbles;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPie;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPiston;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPistonHead;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPortal;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPressurePlate;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPressurePlatePainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericRope;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericRotatable;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericJar;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLamp;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLantern;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLeaves;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLeavesCacao;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLeavesCherryFlowering;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericRepeater;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericShifted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericPlanksPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericSlab;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericSlabPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericSpikes;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericStairs;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericStairsPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericTorch;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericTrapdoor;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericTrapdoorPainted;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericVeryRotatable;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericCropsWheat;
-import net.minecraft.client.render.block.model.generic.BlockModelGenericWool;
+import net.minecraft.client.render.block.model.generic.*;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
@@ -277,10 +222,11 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelGeneric<>(Blocks.SAND, loadDataModel("minecraft:block/sand")));
         addDispatch(new BlockModelGeneric<>(Blocks.GRAVEL, loadDataModel("minecraft:block/gravel")));
-        addDispatch(new BlockModelGeneric<>(Blocks.SULFUR, loadDataModel("minecraft:block/sulfur")));
+        addDispatch(new BlockModelGeneric<>(Blocks.BRIMSAND, loadDataModel("minecraft:block/brimsand")));
 
         addDispatch(new BlockModelGeneric<>(Blocks.BEDROCK, loadDataModel("minecraft:block/bedrock")));
-        addDispatch(new BlockModelGenericFullyRotatable<>(Blocks.BONESHALE, loadDataModel("minecraft:block/bone_shale")));
+        addDispatch(new BlockModelGenericFullyRotatable<>(Blocks.BONESHALE,
+                loadDataModel("minecraft:block/bone_shale")));
 
         addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING)
             .onRenderLayer(1)
@@ -335,6 +281,9 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericShifted<>(Blocks.SPINIFEX, loadDataModel("minecraft:block/spinifex")).render3D(false));
         addDispatch(new BlockModelGeneric<>(Blocks.ALGAE, loadDataModel("minecraft:block/algae")).render3D(false));
 
+        addDispatch(new BlockModelGeneric<>(Blocks.BONE_PILE, loadDataModel("minecraft:block/bone_pile")).render3D(false));
+        addDispatch(new BlockModelGeneric<>(Blocks.SOULCATCHER, loadDataModel("minecraft:block/soul_catcher")).render3D(false));
+
         addDispatch(new BlockModelGenericFlowerStackable<>(Blocks.FLOWER_YELLOW, "minecraft:block/flower_yellow/").render3D(false));
         addDispatch(new BlockModelGenericFlowerStackable<>(Blocks.FLOWER_RED, "minecraft:block/flower_red/").render3D(false));
         addDispatch(new BlockModelGenericFlowerStackable<>(Blocks.FLOWER_PINK, "minecraft:block/flower_pink/").render3D(false));
@@ -387,9 +336,11 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_DIAMOND_GRANITE, loadDataModel("minecraft:block/ore/diamond/granite")));
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_DIAMOND_PERMAFROST, loadDataModel("minecraft:block/ore/diamond/permafrost")));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.CRYSTAL, loadDataModel("minecraft:block/nether_crystal/crystal")));
-        addDispatch(new BlockModelGeneric<>(Blocks.CRYSTAL_STALK, loadDataModel("minecraft:block/nether_crystal/stalk")).render3D(false));
-        addDispatch(new BlockModelGeneric<>(Blocks.NETHERRACK_CRYSTALLINE, loadDataModel("minecraft:block/nether_crystal/crystal_netherrack")));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS, loadDataModel("minecraft:block/rubyglass/block")));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_PURE, loadDataModel("minecraft:block/rubyglass/block_pure")).forceCullSelf(true));
+        addDispatch(new BlockModelCrystalBud<>(Blocks.RUBYGLASS_SPROUT, loadDataModel("minecraft:block/rubyglass/sprout")));
+        addDispatch(new BlockModelGenericRubyglassBud<>(Blocks.RUBYGLASS_BUD));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_CIRCUIT, loadDataModel("minecraft:block/rubyglass/circuit")));
 
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_NETHERRACK, loadDataModel("minecraft:block/ore/nethercoal/netherrack")));
 
@@ -537,10 +488,9 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericVeryRotatable<>(Blocks.PUMPKIN_CARVED_ACTIVE, loadDataModel("minecraft:block/pumpkin_carved_lit")));
         addDispatch(new BlockModelGenericVeryRotatable<>(Blocks.PUMPKIN_REDSTONE, loadDataModel("minecraft:block/pumpkin_redstone")));
 
-
         addDispatch(new BlockModelGeneric<>(Blocks.COBBLE_NETHERRACK, loadDataModel("minecraft:block/cobbled_netherrack/normal")));
-        addDispatch(new BlockModelGeneric<>(Blocks.COBBLE_NETHERRACK_IGNEOUS, loadDataModel("minecraft:block/cobbled_netherrack/igneous")));
-        addDispatch(new BlockModelGeneric<>(Blocks.COBBLE_NETHERRACK_MOSSY, loadDataModel("minecraft:block/cobbled_netherrack/mossy")));
+        addDispatch(new BlockModelGeneric<>(Blocks.MAGMA, loadDataModel("minecraft:block/magma")));
+        addDispatch(new BlockModelGeneric<>(Blocks.COBBLE_NETHERRACK_CRYSTALLINE, loadDataModel("minecraft:block/cobbled_netherrack/crystalline")));
         addDispatch(new BlockModelGeneric<>(Blocks.NETHERRACK, loadDataModel("minecraft:block/netherrack")));
         addDispatch(new BlockModelGeneric<>(Blocks.BRICK_NETHERRACK, loadDataModel("minecraft:block/brick_netherrack")));
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_NETHERRACK_POLISHED, loadDataModel("minecraft:block/slab/polished_netherrack/lower"), loadDataModel("minecraft:block/slab/polished_netherrack/upper"), loadDataModel("minecraft:block/slab/polished_netherrack/full")));
@@ -600,6 +550,11 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelGenericMatcher<>(Blocks.MATCHER, "minecraft:block/matcher/"));
         addDispatch(new BlockModelGenericMatcher<>(Blocks.MATCHER_ACTIVE, "minecraft:block/matcher/active"));
+
+        addDispatch(new BlockModelGeneric<>(Blocks.THERMAL_VENT, loadDataModel("minecraft:block/thermal_vent")));
+
+        addDispatch(new BlockModelGeneric<>(Blocks.GLOOMSTONE, loadDataModel("minecraft:block/gloomstone")));
+        addDispatch(new BlockModelGeneric<>(Blocks.COBBLE_GLOOMSTONE, loadDataModel("minecraft:block/cobbled_gloomstone")));
     }
 }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelCrystalBud.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelCrystalBud.java
new file mode 100644
index 000000000..a636a5e0f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelCrystalBud.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRotatable;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelCrystalBud<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelCrystalBud(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelCrystalBud(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicRotatable.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        switch (direction) {
+            case UP -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case DOWN -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 1, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, -1, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassBud.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassBud.java
new file mode 100644
index 000000000..e8ab93388
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassBud.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRubyglassCrop;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericRubyglassBud<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[BlockLogicRubyglassCrop.MAX_GROWTH_STATE + 1];
+    public BlockModelGenericRubyglassBud(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass_bud/stage0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass_bud/stage" + i).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data % this.models.length];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index 94af132cc..17c8a725f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.dynamictexture;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.world.Dimension;
 import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureWaterFlow extends DynamicTexture {
@@ -77,11 +78,24 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			}
 
 			float var13 = bright * bright;
-			int r = (int) (32.0F + var13 * 32.0F);
-			int g = (int) (50.0F + var13 * 64.0F);
-			int b = 255;
+
+			int colorMax = 255;
+			int colorMid = (int) (50.0F + var13 * 64.0F);
+			int colorMin = (int) (32.0F + var13 * 32.0F);
+
+			int r = colorMin;
+			int g = colorMid;
+			int b = colorMax;
 			int a = (int) (146.0F + var13 * 50.0F);
 
+			if (this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
+				float brightness = 0.75F;
+				r = (int) (255 * brightness);
+				g = (int) (colorMin * brightness);
+				b = (int) (colorMin * brightness);
+				a = (int) (225.0F + var13 * 25.0F);
+			}
+
 			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
